<template lang="pug">
	article.listadoBusqueda
		header: .columnas
			.columna: h2 archivo
			.columna: h2 categoria
			.columna: h2 etiquetas

		ul( v-if="resultados.length" )
			template(v-for="item in resultados")
				li(@click="obtener(item.id)", :data-id="item.id" )
					.archivo
						figure( v-if="item.miniatura" ): img( :src="item.miniatura", :alt="item.nombre" )
						IconoFichero( v-else, :ext="item.tipo")
						//- IconoFichero(:ext="item.tipo")
						p() {{ item.nombre}}.{{ item.tipo}}
					.info
						router-link( :to="{name:'categoria', params:{id:item.categoria.id}}" ) {{item.categoria.nombre}}
						//-p {{item.categoria.nombre}}
						//-router-link( :to="{name:'carpeta', params:{id:item.categoria.id}}" ) {{item.categoria.nombre}}
					.info
						//-p( v-for="etiqueta in item.etiquetas" ) {{ etiqueta.nombre }}
						router-link(
							v-for="etiqueta in item.etiquetas",
							:key="etiqueta.id",
							:to="{name:'etiqueta', params:{id:etiqueta.id}}"
						) {{ etiqueta.nombre }}
					.acciones
						button( type="button", @click.stop="compartir(item.id)", v-tooltip="'Compartir'" ).compartir
							vector(src="~@img/ico-compartir.svg?inline")
						//-button( type="button", @click.stop="borrar(item.id)" ).eliminar: vector( src="~@img/ico-borrar.svg?inline")
						//-button( type="button" ).favorito: vector( src="@img/ico-favorito.svg?inline")
						button.favorito(
							type="button"
							v-tooltip="'Marcar como'"
							@click.stop="marcar( item.id )"
							:class="{ marcado: esFavorito( item.id )}"
							)
							vector( src="@img/ico-favorito.svg?inline")
						button( type="button", @click.stop="descargar(item.id)",
							v-tooltip="'Descargar'" ).descargar: vector( src="@img/ico-descargar.svg?inline")
						button( type="button", :disabled="!tienePrevio( item.tipo )", @click.stop="ver( item.id )",
							v-tooltip="'Previsualizar'" ).ver: vector( src="@img/ico-ver.svg?inline")
				//- li.detalle(:class="'d'+item.id"): detalleArchivo( :archivo="item")


		h3( v-else ) No hay resultados

		modal.edicion(
			name="editarArchivo",
			:max-width="640",
			:max-height="640",
			:adaptive="true",
			width="80%",
			height="90%"
			)
			button.cerrar(
				type="button",
				@click="$modal.hide('editarArchivo')" ) &times;
			detalleArchivo( v-if="archivo" :archivo="archivo", ref="detalleArchivo")


		modal.previo(
			name="previoBusqueda",
			:max-width="640",
			:max-height="640",
			:adaptive="true",
			width="80%",
			height="90%"
			)
			button.cerrar(
				type="button",
				@click="$modal.hide('previoBusqueda')" ) &times;
			figure( v-if="archivo && esImagen(archivo.tipo)" )
				img( :src="previo( archivo.id )", :alt="archivo.descripcion")
			video( v-if="archivo && esVideo(archivo.tipo)", "controls", "autoplay" )
				source( :src="previo( archivo.id )", :type="'video/'+archivo.tipo")
			iframe( v-if="archivo && esArchivo(archivo.tipo)", :src="previo( archivo.id )", "sandbox")


	//-table
		thead: tr
			th.archivo Archivo
			th.usuario Usuario
			th.acciones Acciones
		tbody
			tr( v-for="item in lista" )
				td.archivo: .info
					icono(:ext="item.ext").min
					p {{ item.nombre}}
				td.usuario: .info
					p {{ item.propietario }}

				td.acciones
					button( type="button" ).eliminar: vector( src="~@img/ico-borrar.svg?inline")
					button( type="button" ).favorito: vector( src="@img/ico-favorito.svg?inline")
					button( type="button" ).descargar: vector( src="@img/ico-descargar.svg?inline")
					button( type="button" ).ver: vector( src="@img/ico-ver.svg?inline")
					button( type="button" ).compartir: vector( src="@img/ico-compartir.svg?inline")
					//- button( type="button" ) descargar
					//- button( type="button" ) ver
					//- button( type="button" ) compartir

</template>

<script>
	import IconoFichero from "@/components/IconoFichero";
	import DetalleArchivo from "@/components/DetalleArchivo";
	import router from "@/router";
	import { archivos } from "@/api";
	import { mapState, mapActions, mapGetters } from "vuex";

	export default {
		name: "Listado",
		components: {
			IconoFichero,
			DetalleArchivo
		},
		data() {
			return {
			};
		},
		computed: {
			...mapState(["resultados", "archivo"]),
			...mapGetters(["esFavorito"])
		},
		methods: {
			obtener(id){
				//console.debug(archivo);
				this.obtenerArchivo({ id });
				// console.debug(this.archivo);
				// console.debug(this.$refs);
				// console.debug(this.$refs.detalleArchivo);
				this.$modal.show("editarArchivo");
				// this.$refs.detalleArchivo.archivo = archivo;
			},
			esImagen(tipo) {
				const imagenes = ["jpg", "png", "webp", "gif", "psd"];
				return imagenes.includes(tipo.toLowerCase());
			},
			esVideo(tipo) {
				const videos = ["mp4"];
				return videos.includes(tipo.toLowerCase());
			},
			esArchivo(tipo) {
				const archivos = ["pdf"];
				return archivos.includes(tipo.toLowerCase());
			},
			tienePrevio(tipo) {
				return (
					this.esImagen(tipo) ||
					this.esVideo(tipo) ||
					this.esArchivo(tipo)
				);
			},
			previo(id) {
				return archivos.previo(id);
			},
			compartir(id) {
				this.$root.$emit("archivo-compartir", id);
			},
			marcar(id) {
				this.marcarArchivo({ id, marcar: !this.esFavorito(id) });
			},
			ver(id) {
				//this.archivo = archivo;
				this.obtenerArchivo({ id });
				this.$modal.show("previoBusqueda");
			},
			descargar(id) {
				archivos.descargar(id);
			},
			...mapActions(["marcarArchivo", "obtenerArchivo", "borrarArchivo"])
		},
		mounted(){
			this.$root.$on("archivo-previo", archivo => {
				//this.archivo = archivo;
				this.$modal.show("previoBusqueda");
			});
		}
	};
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	.listadoBusqueda
		li
			display flex
			align-items center
			justify-content space-between
			padding .5rem .5rem
			border-bottom 1px solid lighten( gris, 50% )
			cursor pointer

			&:hover
				background-color tint( azul, 90% )

		p
			color lighten( negro, 40% )
			font-size calcRem( 12 )

		.archivo
			flex 0 0 30%
			display flex
			align-items center

			> *
				margin 0 .5rem

			.iconoFichero
				width 24px
				margin-right .5rem

		.info
			flex 0 0 20%
			display flex
			flex-wrap wrap
			align-items center

			> *
				margin 0 .5rem

			img
				width 15px

			a
				color blanco
				text-decoration none
				font-size calcRem( 12 )
				background-color azul
				white-space nowrap
				line-height 1
				padding .2em .5em
				border-radius 2rem
				margin .1rem .1rem

		.acciones
			flex 0 1 auto
			margin-left auto
			display flex
			justify-content space-between

			button
				flex 0 0 32px
				border none
				width 32px
				height 32px
				border-radius 1rem
				display flex
				align-items center
				justify-content center
				padding 0
				margin 0 .1rem
				cursor pointer
				color tint( azul, 40% )
				background-color transparente

				&[disabled]
					opacity .5
					color gris

				&:hover
					background-color tint( azul, 90% )

				.vector
					height 20px

					svg
						display block

				&.marcado
					background-color tint( azul, 50% )
					color blanco

			.eliminar
				color tint( rojo, 40% )

		h3
			padding 1rem
			font-size calcRem( 14 )
			color lighten( gris, 50% )

		header
			border-radius 0
			background-color negro

			.columnas
				display flex

				.columna
					flex 0 0 20%

					&:first-child
						flex 0 0 30%
						text-align center

					&:last-child()
						flex 0 1 auto

					h2
						padding .5rem 1rem
						text-transform uppercase
						color blanco
						font-size calcRem( 12 )

	.previo

		>>> .v--modal
			background-repeat no-repeat
			background-size 32px
			background-position center
			background-image url( "/img/cargando.gif" )


		.cerrar
			absolute top right
			padding .2rem .4rem
			color tint( azul, 40% )
			background-color blanco
			font-size 1.5rem
			cursor pointer
			font-weight bold
			z-index 1

		video
			absolute top left right bottom
			width 100%
			height 100%
		iframe
			absolute top left right bottom
			width 100%
			height 100%

		figure
			absolute top left right bottom
			display flex
			align-items center
			z-index 0

			img
				max-width 100%
				max-height 100%

	.edicion
		.cerrar
			absolute top right
			padding .2rem .4rem
			color tint( azul, 40% )
			background-color blanco
			font-size 1.5rem
			cursor pointer
			font-weight bold
			z-index 1

		.detalleArchivo
			absolute top 2rem left right bottom
			width auto
			height auto

			>>> header
				display none

			>>> .imagen
				justify-content center
				align-items stretch
				margin-bottom 1rem

				.miniatura
					//max-width 320px
					margin 0 auto
					&::before
						content: none

					img
						max-width 640px
						//width: auto
						height: auto
						position: static

			>>> .contenedor
				height 100%

			>>> .contenido
				padding 2rem 1rem
				background-color blanco


</style>
